#!/usr/bin/env python

### setup.py

from distutils.core import setup

setup(name='Bit2DArray',
      version='1.0',
      author='Avinash Kak',
      author_email='kak@purdue.edu',
      maintainer='Avinash Kak',
      maintainer_email='kak@purdue.edu',
      url='http://RVL4.ecn.purdue.edu/~kak/distBit2DArray/Bit2DArray-1.0.html',
      download_url='http://RVL4.ecn.purdue.edu/~kak/distBit2DArray/Bit2DArray-1.0.tar.gz?download',
      description='A memory efficient packed representation of 2D bit arrays',
      long_description=''' 

This module utilizes the facilities of the **BitVector**
class to create a memory efficient representation for 2D bit
arrays.

The class supports the following operators/methods:

-    __str__
-    __getitem__
-    __setitem__
-    __getslice__
-    __eq__
-    __ne__
-    __and__
-    __or__
-    __xor__
-    __invert__
-    deep_copy
-    size
-    read_bit_array_from_char_file
-    read_bit_array_from_binary_file
-    write_bit_array_to_char_file
-    write_bit_array_to_packed_binary_file
-    shift
-    dilate
-    erode

          ''',

      license='Python Software Foundation License',
      keywords='2D bit array, binary image, 2D bit field',
      platforms='All platforms',
      classifiers=['Topic :: Utilities', 'Programming Language :: Python'],
      packages=['']
)
